<?php
/*
    pmacct-fe is Copyright (C) 2005 by Paolo Lucente

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

function PrintTrafficReportForm($ObsPoint, &$ReportType, &$Capabilities, &$Dates)
{
?>
    <form method="post" action="TrafficReport.php">
    <input type="hidden" name="ObsPoint" value="<?php print trim($ObsPoint['id']) ?>" />
    <input type="hidden" name="RepType" value="<?php print $ReportType['id'] ?>" />

    <table style="background-color: #f0f8ff; border: 1px solid #4682b4; width: 99%; margin: 5px;">
    <tr>
    <td style="width: 33%; text-align: center;">Network Object</td>
    <td style="width: 33%; text-align: center;">Time period</td>
    <td style="width: 33%; text-align: center;">Order by</td>
    </tr>

    <tr>
    <td style="width: 33%; text-align: center;"><select name="network_object">
<?php
    foreach ($Capabilities as $row) {
	if ($ReportType['id'] == $row['report_type']) {
            print "<option value=\"" . trim($row['object']) . "\">" . trim($row['description']) . "</option>";
	}
    }
?>

    </select></td>
    <td style="width: 33%; text-align: center;">S <select name="period_start">
<?php
    foreach ($Dates as $row) {
      print "<option value=\"" . $row['stamp_inserted'] . "\">" . $row['stamp_inserted'] . "</option>";
    }
?>

    </select></td>

    <td style="width: 33%; text-align: center;"><select name="order">
    <option value="tot_bytes">Traffic</option>
    <option value="ip_src">
    <?php isset($ReportType['report_prefs']['sfield_label']) ? print $ReportType['report_prefs']['sfield_label'] : print "Network object" ?>
    </option>
    </select></td>
    </tr>

    <tr><td colspan=3></td></tr><tr><td></td>

    <td style="width: 33%; text-align: center;">E <select name="period_end">
<?php
    foreach ($Dates as $row) {
      print "<option value=\"" . $row['stamp_inserted'] . "\">" . $row['stamp_inserted'] . "</option>";
    }
?>

    </select></td>
    <td style="width: 33%; text-align: center;">Limit results</td></tr>
    <tr>
    <td colspan=2></td>
    <td style="width: 33%; text-align: center;"><input type="text" value="0" name="limit" size=5/></td>
    </tr>

    <tr><td style="text-align: center;" colspan=3>
    <input type="submit" value="Create report">
    </td></tr>
    </table>

    </form>

<?php
}

function PrintNoObsPoints()
{
?>
    <table style="background-color: #fffafa; border: 1px solid #cc6699; width: 99%; margin: 5px;">
    <tr><td style="text-align: center; font-weigth: bold;">No Observation Points have been defined.</td></tr>
    <tr><td style="text-align: center;"><form method="post" action="index.php"><input type="submit" value="Reload page"></form></td></tr>
    </table>

<?php
}

function PrintNoCapabilities()
{
    PrintObsPointSelectionBox();
?>
    <table style="background-color: #fffafa; border: 1px solid #cc6699; width: 99%; margin: 5px;">
    <tr><td style="text-align: center; font-weigth: bold;">You have no capabilities on the selected Observation Point.</td></tr>
    </table>

<?php
    PrintReloadPageBox("Reload page");
}

function PrintBoxedNoReportEntries()
{
?>
    <table style="background-color: #fffafa; border: 1px solid #cc6699; width: 99%; margin: 5px;">
    <tr><td style="text-align: center; font-weigth: bold;">Sorry, no entries found.</td></tr>
    </table>
    
<?php
}

function PrintNoReportEntries()
{
?>
    <table style="background-color: #fffafa; border: 1px solid #cc6699; width: 99%; margin: 5px;">
    <tr><td style="text-align: center; font-weigth: bold;">Sorry, no entries found.</td></tr>
    </table>

<?php
    PrintReloadPageBox("New query");
}

function PrintNoReportForm()
{
?>
    <table style="background-color: #fffafa; border: 1px solid #cc6699; width: 99%; margin: 5px;">
    <tr><td style="text-align: center; font-weigth: bold;">The requested report type has not been implemented yet.</td></tr>
    </table>

<?php
}

function PrintReportValidationError()
{
?>
    <table style="background-color: #fffafa; border: 1px solid #cc6699; width: 99%; margin: 5px;">
    <tr><td style="text-align: center; font-weigth: bold;">Error while validating the requested report type. Details have been logged for the Administrator.</td></tr>
    </table>

<?php
}

function PrintObsPointSelectionBox()
{
    global $ObsPoints;
    global $SelectedObsPoint;

    if (!isset($ObsPoints[0])) {
        PrintNoObsPoints();
    }
    else {
?>
        <form method="post" action="index.php">
        <table style="background-color: #fefbf3; border: 1px solid #ff9900; width: 99%; margin: 5px;">
        <tr><td style="text-align: center; font-weigth: bold;">Observation Point</td></tr>
        <tr><td style="text-align: center;"><select name="ObsPoint">
<?php
        foreach ($ObsPoints as $row) {
	    $String = "<option value=\"" . trim($row['id']) . "\"";
	    if ($SelectedObsPoint['id'] == $row['id']) $String .= " selected";
	    $String .= ">" . trim($row['description']) . "</option>";
	    print $String;
        }
?>
        </select></td></tr>
	<tr><td><br></td></tr>
        <tr><td style="text-align: center;"><input type="submit" value="Select Observation Point"></td></tr>
        </table>
        </form>
<?php
    }
}

function ReportTypeSelectionBox()
{
    global $Capabilities;
    global $ReportDescriptions;
    global $SelectedReportType;

    $LC_ReportDescriptions = $ReportDescriptions;

?>
    <form method="post" action="index.php">
    <table style="background-color: #f0fff0; border: 1px solid #339999; width: 99%; margin: 5px;">
    <tr><td style="text-align: center; font-weigth: bold;">Report</td></tr>
    <input type="hidden" name="ObsPoint" value="<?php print trim($Capabilities[0]['obs_point']) ?>" />
    <tr><td style="text-align: center;"><select name="RepType">
<?php
    foreach ($Capabilities as $row) {
	foreach ($LC_ReportDescriptions as $key2 => $row2) {
	    if ($row['report_type'] == $row2['id']) {
		$LC_ReportDescriptions[$key2]['id'] = 0; /* Let us to count once each Report Type available */ 
		$String = "<option value=\"" . $row['report_type'] . "\"";
		if ($SelectedReportType == $row['report_type']) $String .= " selected";
		$String .= ">" . trim($row2['description']) . "</option>";
		print $String;
	        break;
	    }
        }
    }
?>
    </select></td></tr>
    <tr><td><br></td></tr>
    <tr><td style="text-align: center;"><input type="submit" value="Select Report Type"></td></tr>
    </table>
    </form>

<?php
}

function PrintReloadPageBox($ButtonText)
{
?>
    <br><br>
    <table style="background-color: #fffafa; border: 1px solid #9933cc; width: 99%; margin: 5px;">
    <tr><td style="text-align: center;"><form method="post" action="index.php">
    <input type="hidden" name="Reload" value="1" />
    <input type="submit" value="<? print $ButtonText ?>"></form></td></tr>
    </table>

<?php
}

function HandleReportFormError()
{
?>
    <table style="border: 1px solid #999; width: 99%; margin: 5px;">
    <tr><td style="text-align: center; font-weigth: bold;">
    One or more required parameters are missing or not correct. Try submitting again your data. Thank you.
    </td></tr>
    </table>

<?php
}

function PrintDBConnectionFailed($ErrMsg)
{
?>
    <table style="background-color: #fffafa; border: 1px solid #cc6699; width: 99%; margin: 5px;">
    <tr><td style="text-align: center; font-weigth: bold;">Failed to connect to the DB. <?php if (isset($ErrMsg)) print $ErrMsg ?></td></tr>
    </table>

<?php
}

function PrintDBQueryFailed($ErrMsg)
{
?>
    <table style="background-color: #fffafa; border: 1px solid #cc6699; width: 99%; margin: 5px;">
    <tr><td style="text-align: center; font-weigth: bold;">Failed SQL query. <?php if (isset($ErrMsg)) print $ErrMsg ?></td></tr>
    </table>

<?php
}

function PrintMissingConfig()
{
?>
    <table style="background-color: #fffafa; border: 1px solid #cc6699; width: 99%; margin: 5px;">
    <tr><td style="text-align: center; font-weigth: bold;">Missing configuration array. Session problem ?!</td></tr>
    </table>

<?php
}

function PrintFileNotFound($filename)
{
?>
    <table style="background-color: #fffafa; border: 1px solid #cc6699; width: 99%; margin: 5px;">
    <tr><td style="text-align: center; font-weigth: bold;">Missing defined file: <?php print $filename ?></td></tr>
    </table>

<?php
}

function PrintPlotForm(&$GetArray)
{
    print "<form method=\"get\" action=\"PlotTrafficEntry.php\">";
    foreach ($GetArray as $key => $row) {
	print "<input type=\"hidden\" name=\"" . $key . "\" value=\"" . $row . "\"/>";
    }
?>
    <table style="background-color: #f5f5f5; border: 1px solid #999; width: 99%; margin: 5px;">
    <tr><td style="font-weigth: bold;">Number of points: <input type="text" name="numpoints" value="24" size=5/></td></tr>
    <tr><td style="text-align: center; font-weigth: bold;"><input type="submit" value="Plot"/></td></tr>
    </table>

<?php
}

function PrintTrafficReport($SelectedObsPoint, $ReportType, &$Period, $object, &$Entries)
{
?>
    <h3>Network traffic summary</h3>
    <table style="background-color: #f5f5f5; border: 1px solid #999; width: 99%; margin: 5px;">
<?php
    if ($Period['start'] == $Period['end']) print "<tr><td>Time period: <b>" . $Period['start'] . "</b></td></tr>";
    else print "<tr><td>Time period: <b>" . $Period['start'] . "</b>  -  <b>" . $Period['end'] . "</b></td></tr>";
    if (isset($ReportType['report_prefs']['stepping'])) print "<tr><td>Stepping: <b>" . $ReportType['report_prefs']['stepping'] . "</b></td></tr>"; 
?>
    </table>

    <table style="border: 1px solid #999; width: 99%; margin: 5px;">
    <tr><td><? isset($ReportType['report_prefs']['sfield_label']) ? print $ReportType['report_prefs']['sfield_label'] : print "Network Object" ?>
    </td>
    <? isset($ReportType['report_prefs']['no_direction']) ? print "<td colspan=3>Total Traffic</td><td>Last Packet</td><td>Functions</td></tr>" :
	print "<td colspan=3>In Traffic</td><td colspan=3>Out Traffic</td><td>Total Traffic</td><td>Last Packet</td><td>Functions</td></tr>" ?>

<?php
    $row_counter = 0;

    foreach ($Entries as $row) {
        $bg_color = $row_counter % 2 ? "bbb" : "ccc";
        print "<tr style=\"background-color: #" . $bg_color . ";\">";
        print "<td><a href=\"javascript:openNewWindow('ResolveIP.php?ip=" . $row['ip_src'] . "');\">" . $row['ip_src'] . "</a></td>";
	if (isset($ReportType['report_prefs']['no_ports']) && ($ReportType['report_prefs']['no_ports'] == TRUE)) {
	    $String = "<td>" . HandleBytes($row['in_bytes'], 2);
	    $String .= "<td>" . HandleBytesPerSecond($row['in_bytes'], $row['stamp_inserted'], $row['stamp_updated']) . "</td>";
	    $String .= "<td>" . HandlePktsPerSecond($row['in_pkts'], $row['stamp_inserted'], $row['stamp_updated']) . "</td>"; 
	    print $String;
	    if (!isset($ReportType['report_prefs']['no_direction'])) {
		$String = "<td>" . HandleBytes($row['out_bytes'], 2) . "</td>";
		$String .= "<td>" . HandleBytesPerSecond($row['out_bytes'], $row['stamp_inserted'], $row['stamp_updated']) . "</td>"; 
		$String .= "<td>" . HandlePktsPerSecond($row['out_pkts'], $row['stamp_inserted'], $row['stamp_updated']) . "</td>"; 
		print $String;
	    }
	}
	else {
            $String = "<td><a href=\"javascript:openNewLargeWindow('PortsReport.php?obj=" . urlencode($object);
	    $String .= "&obj2=" . urlencode($row['ip_src']);
	    $String .= "&reptype=" . $ReportType['id'];
            if (!isset($ReportType['report_prefs']['no_direction'])) $String .= "&dir=in&obspoint=" . trim($SelectedObsPoint['id']);
            else $String .= "&dir=both&obspoint=" . trim($SelectedObsPoint['id']);
            $String .= "&pstart=" . urlencode($Period['start']) . "&pend=" . urlencode($Period['end']) . "');\">";
	    $String .= HandleBytes($row['in_bytes'], 2) . "</a></td>";
	    $String .= "<td>" . HandleBytesPerSecond($row['in_bytes'], $row['stamp_inserted'], $row['stamp_updated']) . "</td>"; 
	    $String .= "<td>" . HandlePktsPerSecond($row['in_pkts'], $row['stamp_inserted'], $row['stamp_updated']) . "</td>"; 
            print $String;

	    if (!isset($ReportType['report_prefs']['no_direction'])) {
        	$String = "<td><a href=\"javascript:openNewLargeWindow('PortsReport.php?obj=" . urlencode($object);
		$String .= "&obj2=" . urlencode($row['ip_src']);
		$String .= "&reptype=" . $ReportType['id'];
        	$String .= "&dir=out&obspoint=" . trim($SelectedObsPoint['id']);
        	$String .= "&pstart=" . urlencode($Period['start']) . "&pend=" . urlencode($Period['end']) . "');\">";
		$String .= HandleBytes($row['out_bytes'], 2) . "</a></td>";
		$String .= "<td>" . HandleBytesPerSecond($row['out_bytes'], $row['stamp_inserted'], $row['stamp_updated']) . "</td>";
		$String .= "<td>" . HandlePktsPerSecond($row['out_pkts'], $row['stamp_inserted'], $row['stamp_updated']) . "</td>"; 
        	print $String;
	    }
        }
	
        if (!isset($ReportType['report_prefs']['no_direction'])) print "<td>" . HandleBytes($row['tot_bytes'], 2) . "</td>";
	print "<td>" . $row['stamp_updated'] . "</td>";

        if (isset($_SESSION['config']['prefs']['jpgraph_path']) && isset($ReportType['report_prefs']) && isset($ReportType['report_prefs']['stepping'])) {
	    $String = "<td><a href=\"javascript:openNewLargeWindow('PlotTrafficEntry.php?obj=" . urlencode($object);
	    $String .= "&obj2=" . urlencode($row['ip_src']);
            $String .= "&reptype=" . $ReportType['id'];
            $String .= "&obspoint=" . trim($SelectedObsPoint['id']);
            $String .= "&numpoints=0";
            $String .= "&pstart=" . urlencode($Period['start']);
            $String .= "&pend=" . urlencode($Period['end']);
            $String .= "');\">Plot</a></td>";
            print $String;
	}
	else print "<td></td>";

	print "</tr>";
	$row_counter++;
    }
?>

    </table>

    <table style="border: 1px solid #999; width: 99%; margin: 5px;">
    <tr><td style="text-align: center;"><form method="post" action="index.php">
    <input type="hidden" name="ObsPoint" value="<?php print trim($SelectedObsPoint['id']) ?>" />
    <input type="hidden" name="RepType" value="<?php print $ReportType['id'] ?>" />
    <input type="submit" value="New query"></form></td></tr>
    </table>

<?php
}

function PrintPortsReport(&$SelectedObsPoint, $ip, &$SelectedReportType, $Direction, &$Period, &$PortSrcEntries, &$PortDstEntries, $PrintHeader)
{
?>
    <? $PrintHeader ? print "<h3>Port traffic summary</h3>" : print "<br>" ?>
    <table style="background-color: #f5f5f5; border: 1px solid #999; width: 97%; margin: 5px;">
    <tr><td><?php isset($SelectedReportType['report_prefs']['sfield_label']) ? print $SelectedReportType['report_prefs']['sfield_label'] . ": " : print "Network object: " ?>
    <b><?php print $ip ?></b></td></tr> 
    <tr><td>Direction: <b><?php print $Direction ?></b></td></tr>
<?php
    if ($Period['start'] == $Period['end']) print "<tr><td>Time period: <b>" . $Period['start'] . "</b></td></tr>";
    else print "<tr><td>Time period: <b>" . $Period['start'] . "</b>  -  <b>" . $Period['end'] . "</b></td></tr>";
?>
    </table>

    <table style="border: 1px solid #999; width: 97%; margin: 5px;">
    <tr><td>Dst port</td><td>Protocol</td><td>Traffic</td><td>Last packet</td></tr>
<?php
    $row_counter = 0;
    foreach ($PortDstEntries as $row) {
        $bg_color = $row_counter % 2 ? "bbb" : "ccc";
        print "<tr style=\"background-color: #" . $bg_color . ";\">";
        print "<td>" . $row['port_dst'] . "</td>";
        print "<td>" . $row['ip_proto'] . "</td>";
        print "<td>" . HandleBytes($row['bytes'], 2) . "</td>";
        print "<td>" . $row['stamp_updated'] . "</td>";
        print "</tr>";
        $row_counter++;
    }
?>
    </table>

    <table style="border: 1px solid #999; width: 97%; margin: 5px;">
    <tr><td>Src port</td><td>Protocol</td><td>Traffic</td><td>Last packet</td></tr>
<?php
    $row_counter = 0;
    foreach ($PortSrcEntries as $row) {
        $bg_color = $row_counter % 2 ? "bbb" : "ccc";
        print "<tr style=\"background-color: #" . $bg_color . ";\">";
        print "<td>" . $row['port_src'] . "</td>";
        print "<td>" . $row['ip_proto'] . "</td>";
        print "<td>" . HandleBytes($row['bytes'], 2) . "</td>";
        print "<td>" . $row['stamp_updated'] . "</td>";
        print "</tr>";
        $row_counter++;
    }
?>
    </table>

<?php
}
