<?php
/*
    pmacct-fe is Copyright (C) 2005 by Paolo Lucente

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

function Merge_In_Out_Results(&$In, &$Out, $Values, &$Period, &$Result)
{
    $index = 0;
    $match = 0;

    if (!is_array($In) && !is_array($Out)) return; /* We exit here whether no entries are found */
    if (!getPeriod($Period)) {
	if (is_array($In) && !isset($In[0]['stamp_inserted']) || (is_array($Out) && !isset($Out[0]['stamp_inserted'])))
	    return; /* We are missing the time period */
    }

    if (is_array($In)) {
        foreach ($In as $key_in => $row_in) {
            $match = FALSE;
	    if (is_array($Out)) {
                foreach ($Out as $key_out => $row_out) {
                    if ($row_in[$Values['sfield_in']] == $row_out[$Values['sfield_out']]) {
                        $Result[$index]['ip_src'] = $row_out[$Values['sfield_out']];
                	$Result[$index]['in_bytes'] = $row_in['bytes'];
                	$Result[$index]['in_pkts'] = $row_in['packets'];
                	$Result[$index]['out_bytes'] = $row_out['bytes'];
                	$Result[$index]['out_pkts'] = $row_out['packets'];
                	$Result[$index]['tot_bytes'] = $row_in['bytes']+$row_out['bytes'];
                	if (getPeriod($Period) && !getPeriodSI($Period)) $Result[$index]['stamp_inserted'] = $Period['start'];
                	else $Result[$index]['stamp_inserted'] = $row_out['stamp_inserted'];
                	$Result[$index]['stamp_updated'] = $row_out['stamp_updated'] > $row_in['stamp_updated'] ? $row_out['stamp_updated'] : $row_in['stamp_updated'];

                	unset($In[$key_in]);
                	unset($Out[$key_out]);
                	$match = TRUE;
                	$index++;
                        break;
            	    }   
		}
	    }
            /* An element is in the $row_in vector but not in the $row_out */
            if (!$match) {
                $Result[$index]['ip_src'] = $row_in[$Values['sfield_in']];
                $Result[$index]['in_bytes'] = $row_in['bytes'];
                $Result[$index]['in_pkts'] = $row_in['packets'];
                $Result[$index]['out_bytes'] = 0;
                $Result[$index]['out_pkts'] = 0; 
                $Result[$index]['tot_bytes'] = $row_in['bytes'];
                if (getPeriod($Period) && !getPeriodSI($Period)) $Result[$index]['stamp_inserted'] = $Period['start'];
                else $Result[$index]['stamp_inserted'] = $row_in['stamp_inserted'];
                $Result[$index]['stamp_updated'] = $row_in['stamp_updated'];

                unset($In[$key_in]);
                $match = FALSE;
                $index++;
	    }
        }
    }
    /* Let's now process the remaining element in $row_out vector not found in $row_in one */
    if (is_array($Out)) {
        foreach ($Out as $key_out => $row_out) {
            $Result[$index]['ip_src'] = $row_out[$Values['sfield_out']];
            $Result[$index]['in_bytes'] = 0;
            $Result[$index]['in_pkts'] = 0; 
            $Result[$index]['out_bytes'] = $row_out['bytes'];
            $Result[$index]['out_pkts'] = $row_out['packets']; 
            $Result[$index]['tot_bytes'] = $row_out['bytes'];
            if (getPeriod($Period) && !getPeriodSI($Period)) $Result[$index]['stamp_inserted'] = $Period['start'];
	    else $Result[$index]['stamp_inserted'] = $row_out['stamp_inserted'];
            $Result[$index]['stamp_updated'] = $row_out['stamp_updated'];

            unset($Out[$key_out]);
            $index++;
	}
    }
}

function SortResults($order, &$result)
{
    if ($order == 'tot_bytes') {
        usort($result, "Cmp_TotBytes");
    }
    else if ($order == 'ip_src') {
        usort($result, "Cmp_IpSrc");
    }
    else if ($order == 'stamp_inserted') {
	usort($result, "Cmp_StampInserted");
    }
}

function Cmp_TotBytes($a, $b)
{
    if ($a['tot_bytes'] == $b['tot_bytes']) {
        return 0;
    }
    return ($a['tot_bytes'] > $b['tot_bytes']) ? -1 : 1;
}

function Cmp_IpSrc($a, $b)
{
    return strnatcmp($a['ip_src'], $b['ip_src']);
}

function Cmp_StampInserted($a, $b)
{
    $res = strcmp($a['stamp_inserted'], $b['stamp_inserted']); 
    return -$res;
}

function LimitResults($limit, &$result)
{
    $counter = 0;

    foreach ($result as $index => $row) {
	if ($counter < $limit);
	else {
	    unset($result[$index]);
	}
	$counter++;
    }
}
