--
-- # su - postgres  (or whatever your database runs as ... usually postgres)
-- $ psql -d pmacct_fe -f create-table.pgsql 
--

-- Tables 
DROP TABLE capabilities;
DROP TABLE observation_points;
DROP TABLE reports;

CREATE TABLE reports (
	id		INT NOT NULL,
	prefs		CHAR(64) NOT NULL DEFAULT 'none',
	description	CHAR(64) NOT NULL,
	PRIMARY KEY	(id)
); 

CREATE TABLE observation_points (
        id		CHAR(16) NOT NULL,
        dbname          CHAR(16) NOT NULL,
        username        CHAR(16) NOT NULL,
        password        CHAR(16),
        hostname        CHAR(64),
        description     CHAR(64),
        PRIMARY KEY     (id),
        UNIQUE          (id, dbname, username, hostname),
	CONSTRAINT	valid_id CHECK (id SIMILAR TO '[0-9A-z ]+')
);

CREATE TABLE capabilities (
	username	CHAR(64) NOT NULL,
	object		CHAR(40) NOT NULL, -- large enough for tags, IPv4/IPv6 network prefixes and AS numbers
        obs_point	CHAR(16) NOT NULL REFERENCES observation_points(id),
	report_type	SMALLINT NOT NULL REFERENCES reports(id),
	description	CHAR(64) NOT NULL,
	UNIQUE		(username, object, obs_point, report_type)
);

COPY reports FROM stdin USING DELIMITERS ',';
1,none,Traffic Report
101,templates/reports/report-101-prefs.php,Traffic Report with Graphs
\.

-- Perms
GRANT SELECT, INSERT, UPDATE, DELETE ON reports TO pmacct_fe;
GRANT SELECT, INSERT, UPDATE, DELETE ON observation_points TO pmacct_fe;
GRANT SELECT, INSERT, UPDATE, DELETE ON capabilities TO pmacct_fe;

