#!/bin/bash
NETWORKS="150.145.80.0/24 150.145.81.0/24 150.145.82.0/24 150.145.83.0/24 150.145.84.0/24 150.145.85.0/24 150.145.86.0/24 150.145.87.0/24 150.145.88.0/24 150.145.89.0/24 150.145.90.0/24 150.145.91.0/24 150.145.92.0/24 150.145.93.0/24 150.145.94.0/24 150.145.95.0/24"
PGPASSWORD="arealsmartpwd"
export PGPASSWORD

DAY=`psql -t -U pmacct -c "SELECT MIN(DISTINCT(date_trunc('day', stamp_inserted))) FROM acct_out;"` 
DAY=`echo $DAY | sed 's/^ //g'`
DAY=`echo $DAY | sed 's/ $//g'`
DAY=`echo $DAY | sed 's/ .*$//g'`

for net in $NETWORKS
do
  psql -t -U pmacct -c "INSERT INTO daily_stats SELECT '$net' AS ip, 0, SUM(bytes) AS out_bytes, SUM(bytes) AS tot_bytes, date_trunc('day', stamp_inserted) AS day FROM acct_out WHERE ip_src << '$net' AND stamp_inserted LIKE '$DAY%' GROUP BY date_trunc('day', stamp_inserted);"

  if [ $? -eq 0 ]
  then
    /usr/bin/psql -t -U pmacct -c "UPDATE daily_stats SET in_bytes=(SELECT SUM(bytes) FROM acct_in WHERE ip_dst << '$net' AND stamp_inserted LIKE '$DAY%' GROUP BY date_trunc('day', stamp_inserted)), tot_bytes=tot_bytes+(SELECT SUM(bytes) FROM acct_in WHERE ip_dst << '$net' AND stamp_inserted LIKE '$DAY%' GROUP BY date_trunc('day', stamp_inserted)) WHERE ip = '$net' AND day LIKE '$DAY%';"
  fi
done
