<?php
/*
 *      Check REPORT-TYPES document to learn the structure expected by each existing Report Type.
 *
 *	Let's start from a basic SQL query: 
 *      'SELECT <sfield> FROM <table> WHERE <qfield> = <qvalue>'
 *
 *      <qvalue> is taken from the 'object' field of the 'capabilities' table ('pmacct_fe' DB). It's the
 *               set of objects the user can select from the specified Observation Point. 
 *
 *      <qfield> is the SQL field whose values are compared (searching for matches) against the <qvalue>;
 *               The <qfield> is taken from the <table> ('pmacct' DB). 
 *
 *      <sfield> is the SQL field whose values are presented to the user. It's also taken from the <table>
 *		 ('pmacct' DB).
 *
 *      no_ports = Port tables are not defined or not needed. 
 * 
 *      enable_grouping = The <table> sports unused fields other than the <sfield> one. Thus it's needed
 *		 	  to append to the query a 'GROUP' clause.  
 *
 *	stepping = It has to change accordingly to the 'sql_history' value. It's mandatory for graphing
 *                 purposes. Otherwise it's ignored. 
 *
 *	type = Points to a defined Report Type. For a list of defined RTs, check the REPORT-TYPES document. 
 *                        
 *      
 */

$report_prefs = array(
    'type' => '1',		/* Mandatory ! */
    'no_ports' => '0',
    'table_in' => 'acct_v3',
    'table_out' => 'acct_v3',
    'qfield_in' => 'agent_id',
    'qfield_out' => 'agent_id',
    'sfield_in' => 'ip_dst',
    'sfield_out' => 'ip_src',
    'sfield_label' => 'IP Address',
    'enable_grouping' => '1',
    'stepping' => '1h',
);

